-- Sounds
freeslot("sfx_grass1", "sfx_grass2", "sfx_tanuki", "sfx_bjmpsp", "sfx_btwirl", "sfx_tf2pan", "sfx_uigoku", "sfx_mwitem", "sfx_flowey", "sfx_stopsn", "sfx_ghzlol", "sfx_ghzlo2", "sfx_ghzlo3", "sfx_keygen", "sfx_dogtoy", "sfx_metalp", "sfx_dogt2", "sfx_fparry", "sfx_fparr2")
sfxinfo[sfx_grass1].caption = "Blossom Tornado"
sfxinfo[sfx_grass2].caption = "Tornado Cancel"
sfxinfo[sfx_tanuki].caption = "Tanuki Suit"
sfxinfo[sfx_bjmpsp].caption = "Super Jump"
sfxinfo[sfx_btwirl].caption = "Air Twirl"
sfxinfo[sfx_tf2pan].caption = "BONK"
sfxinfo[sfx_uigoku].caption = "no way is tha tthe"
sfxinfo[sfx_mwitem].caption = "Item"
sfxinfo[sfx_flowey].caption = "Mischevious Laughter"
sfxinfo[sfx_stopsn].caption = "Stop Sign"
sfxinfo[sfx_ghzlol].caption = "Familiar Jingle"
sfxinfo[sfx_ghzlo2].caption = "Familiar Jingle"
sfxinfo[sfx_ghzlo3].caption = "Familiar Jingle...?"
sfxinfo[sfx_keygen].caption = "KEYGEN"
sfxinfo[sfx_metalp].caption = "Metal Pipe"
sfxinfo[sfx_dogtoy].caption = "Squeak"
sfxinfo[sfx_dogt2].caption = "Ssquueeaak"
sfxinfo[sfx_fparry].caption = "Parry"
sfxinfo[sfx_fparr2].caption = "Parried!"

-- Objects
freeslot("MT_VINETARG", "MT_DUMMYOBJ", "S_DUMMYSTATE", "SPR_LSTM", "SPR_BLBS", "SPR_FLIM", "SPR_SUPF")

mobjinfo[MT_VINETARG] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_DUMMYSTATE,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	flags = MF_NOGRAVITY
}
mobjinfo[MT_DUMMYOBJ] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_DUMMYSTATE,
	radius = 24*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_SCENERY|MF_NOGRAVITY
}
states[S_DUMMYSTATE] = {SPR_NULL, A, -1, nil, 0, 0, S_DUMMYSTATE}

-- States
freeslot("SPR2_TRND", "S_PLAY_BLOSSOM_TORNADO", "SPR2_DUCK", "S_PLAY_BLOSSOM_DUCKDANCE")
states[S_PLAY_BLOSSOM_TORNADO] = {SPR_PLAY, SPR2_TRND, 3, nil, 0, 0, S_PLAY_BLOSSOM_TORNADO}
states[S_PLAY_BLOSSOM_DUCKDANCE] = {SPR_PLAY, SPR2_DUCK, 4, nil, 0, 0, S_PLAY_BLOSSOM_DUCKDANCE}

-- Commands
COM_AddCommand("blossom_tanukisuit", function(p)
	if srb2p then CONS_Printf(p, "Try this in Sonic Robo Blast 2.") end
	if p.mo.blossom_tanukianim then return end
	p.mo.blossom_tanukianim = 20
	S_StartSound(p.mo, sfx_tanuki)
end)

COM_AddCommand("blossom_brokenthrust", function(p)
	if srb2p then CONS_Printf(p, "Try this in Sonic Robo Blast 2.") end
	if p.mo.skin ~= "blossom" then CONS_Printf(p, "This command only works as Blossom.") end
	if not usedCheats then CONS_Printf(p, "Cheats are disabled in this server.") end
	G_SetUsedCheats()

	p.gigathrust = not p.gigathrust

	if p.gigathrust then
		CONS_Printf(p, "You have become all powerful...")
	else
		CONS_Printf(p, "You have reverted to normal...")
	end
end, COM_ADMIN)

rawset(_G, "cv_nopetals", CV_RegisterVar({
	name = "blossom_nopetals",
	defaultvalue = 0,
	flags = CV_NETVAR|CV_SAVE,
	PossibleValue = CV_OnOff,
}))

-- That's crazy
if not P_MoveOrigin then rawset(_G, "P_MoveOrigin", P_TeleportMove) end
if not P_SetOrigin then rawset(_G, "P_SetOrigin", P_TeleportMove) end

-- ok
rawset(_G, "hasShield", function(p, shield)
	if p.powers[pw_super] then return false end
	return (p.powers[pw_shield] & SH_NOSTACK) == shield
end)